;T[iny]HAP 1.02c
;Copyright (C) 1995 Alexander Krupnik,
;603074,Russia,N.Novgorod,Narodnaja 38-443, phone (831-2) 62-19-20
;This text is provided on an "as is" basis without warranty of any kind.
;Expect that this text will contain spelling and grammar errors.
;How to compile:
;  tasm /m2 thap.asm
;  tlink /t thap.obj

page ,132
.radix 16
.286p
LOCALS
CR              equ     0dh
LF              equ     0ah
InpBSize        equ     2000h             ;Set buffer size for source (8K)
PackBSize       equ     1000h             ;Set buffer size for destination(4K)
NofCntx         equ     05                ;Number of Contexts
MaxCntx         equ   (NofCntx-1)*2
NotUsed         equ   0ffffh
NotFnd          equ   0fffah
NotCntd         equ   0fffch
Hollow          equ   0fff7h
Found           equ   0000
.b              equ   <Byte Ptr>
.w              equ   <Word Ptr>
.d              equ   <DWord Ptr>
.s              equ   <short>
.o              equ   <Offset>
Message         macro   String
                mov     dx,.o String
                call    LDisp
                endm

Quit            macro    Msg
                Message  Msg
                call     DosExit
                endm

Open            macro    FName
                mov      dx,.o FName
                call     FOpen
                endm

Create          macro    FName,Attribute
                mov      cx,Attribute
                mov      dx,.o FName
                call     FCreate
                endm

FSeek           macro    ModeCode,HOffsExpr,LOffsExpx
                mov      al,ModeCode
                HOffsExpr
                LOffsExpx
                call     LSeek
                endm

Read            macro    FHandle,NOfBytes,Buff
                ifnb     <FHandle>
                mov      bx,FHandle
                endif
                mov      cx,NOfBytes
                mov      dx,.o Buff
                call     FRead
                endm

Write           macro    FHandle,NOfBytes,Buff
                ifnb     <FHandle>
                mov      bx,FHandle
                endif
                mov      cx,NOfBytes
                mov      dx,.o Buff
                call     FWrite
                endm

Close           macro    Handle
                mov      bx,Handle
                call     FClose
                endm

SetSS           macro
                mov      ax,cs
                add      ax,500h
                cli
                mov      ss,ax
                mov      sp,200h
                sti
                endm

cseg            segment
                assume  cs:cseg,ds:cseg
                org    0100h       ;.COM format
Main            proc     far
                SetSS              ;Move Stack segment
                call     SetCtrlBR ;Set Ctrl-Break handler
                call     CmdLParse ;Parse the command line for parameters
                call     MemAlloc  ;Allocate memory
                call     CoderIni  ;Initialize packer/unpacker data structures
                cmp      Encode,00 ;
                jz       @@FDecode ;
                                   ;Start of packing
                call     GetNofBl  ;Get number of blocks in a source file
                call     FilePack  ;Pack File
                call     WrPckSize ;Get an archive size
                call     DosExit   ;Exit to DOS

                                   ;Start of unpacking
@@FDecode:      call     FPrep     ;Prepare files for unpacking
                call     PrepToDec ;Prepare to unpacking
                call     FUnPack   ;Unpack a file
                call     SetDate   ;Set attribute, date & time
                                   ; of an unpacked file
                call     DosExit   ;Exit to DOS
Main            endp


FilePack        proc    near
                sub     ax,ax                 ;
                mov     InCntH,ax             ;Zero out unpacked byte
                mov     InCntL,ax             ; counter
                mov     OutCntH,ax            ;Zero out packed byte
                mov     OutCntL,ax            ;  counter
                cmp     NOfBl,00              ;Is file length < InpBSize?
                jz      @@PackRmnd            ; If so, pack Remainder
                                              ;
                mov     cx,NOfBl
@@NxtBl:        push    cx
                                              ;Read block=8k
                Read    RHandle,InpBSize,ReadBuff
                mov     ax,InpBSize           ;Number of bytes to pack
                call    PackBlk               ;Pack block of bytes
                pop     cx                    ;Are all blocks packed?
                loop    @@NxtBl               ; No, pack next block

@@PackRmnd:     cmp     Remndr,00             ;If Remainder=0,
                jz      @@EncFlush            ; flush encoder and exit
                Read    RHandle,Remndr,ReadBuff; else, pack remainder
                mov     ax,Remndr             ;
                call    PackBlk               ;

@@EncFlush:     call    FlushEncoder          ;Output significant bits left in Low
                call    WrRest                ;Write the rest of packed file
                ret                           ;
FilePack        endp


; ax is equal to number of bytes to pack
PackBlk         proc near
                mov     BtTot,ax             ;Number of bytes to pack
                mov     BtRdd,-1             ;Reset input char pointer
even
@@NxtByte:      inc     BtRdd                ;Increment input char pointer
                mov     ax,BtTot             ;
                cmp     BtRdd,ax             ;Are all bytes processed?
                jb      @@GetChar            ; If no, get next char
                ret                          ;   else exit
even
@@GetChar:      mov     si,BtRdd             ;
                mov     al,ReadBuff[si]      ;Read input char
                mov     Char,al              ; and save it
                mov     CntxNmb,MaxCntx      ;
                add     InCntL,01            ;Increment the counter of
                adc     InCntH,00            ; all processed bytes
                mov     cx,ElimPnt           ;
                mov     si,100h              ;
                sub     cx,si                ;
                jz      @@CharEnc            ; If Elim not changed,
                                             ;   encode input char,
                mov     es,ElimSeg           ;   else restore Elim
                sub     bx,bx                ;
@@RestNxt:      mov     bl,.b es:[si]        ;Get address of changed byte
                dec .b  es:[bx]              ;Reset this byte to 0ffh
                inc     si                   ;Point to the next byte
                loop    @@RestNxt            ;
                mov     ElimPnt,100h         ;Restore ElimPnt

even                                         ;Find an existing context
@@CharEnc:      mov     bx,CntxNmb           ;
@@FndExCntx:    cmp     CntxInd[bx],NotUsed  ;  If context does
                jnz     @@FndChar            ;  not exist
                mov     CntxStat[bx],NotUsed ;   check
                sub     bx,02                ;   a lower order
                jmp .s  @@FndExCntx          ;  context

@@FndChar:      mov     CntxNmb,bx           ;First existing context
                call    FindMatch            ;Attempt to find Char in context
                mov     bx,CntxNmb           ;Restore bx
                cmp     ax,NotFnd            ;Is Char not found?
                jnz     @@IsNCntd            ; If not, continue..
                mov     CntxStat[bx],NotFnd  ;If so, take note of it
                sub     bx,02                ;  and try to find Char
                jmp .s  @@FndChar            ; in a lower order context

@@IsNCntd:      mov     CntxStat[bx],NotCntd ;
                cmp     ax,NotCntd           ;Is Char not counted?
                jnz     @@ChFound            ; If not, Char found
                sub     bx,02                ;If so, try to find Char
                jmp .s  @@FndChar            ; in a lower order context

even                                         ;Char found in
@@ChFound:      mov     bx,CntxNmb           ; a context bx
                or      bx,bx                ;Is it a context of lowest order?
                jz      @@NxtCntx            ;Yes, go to higher order context

                cmp     CntxStat[bx],NotCntd ;Is Char found, but freq=0?
                jnz     @@IsNFound           ; No, ...
                                             ;If Char exist,increment
                                             ; frequency
                mov     es,FreqSeg           ;
                mov     di,FrAddr[bx]        ;di points to Char frequency
                cmp .b  es:[di],0ffh         ;Is Frequesy=MaxFrequensy?
                jnz     @@FrInc              ; No, increment frequency
                call    FrScale              ;Yes, scale frequencies
@@FrInc:        inc .b  es:[di]              ;
                jmp .s  @@NxtCntx            ; Go to a higher order context

@@IsNFound:     cmp     CntxStat[bx],NotFnd  ;Is Char not found?
                jnz     @@CntxCreate         ; No, create context

                call    AddToCntx            ;Add char to context
                cmp     ax,0ffffh            ;
                jz      @@CdrIni             ;
                jmp .s  @@NxtCntx            ; Go to a higher order context

@@CntxCreate:   call    CreateCntx           ;Create new context
                cmp     ax,0ffffh            ;Are CntxSz and CntxIni full?
                jz      @@CdrIni             ; Yes, reset coder

                mov     di,CntxNmb           ;
                mov     CntxInd[di],ax       ;Save context index
                mov     si,PrevCntxInd[di-2] ;
                add     si,si                ;Get the
                mov     es,CntxIniSeg        ; beginning of
                mov     si,es:[si]           ; previous context
                add     si,PrevChNbr[di-2]   ;Get previous char position
                add     si,si                ;Link new
                mov     es,LinksSeg          ; context
                mov     es:[si],ax           ; to the previous one
                jmp .s  @@NxtCntx            ;

@@CdrIni:       call    CoderIni
                jmp     @@NxtByte            ;

even
@@NxtCntx:      add     CntxNmb,02           ;Shift to a higher order context
                cmp     CntxNmb,MaxCntx      ;Are all contexts processed?
                ja      @@GetChNbr           ; Yes,get current Char positions
                jmp     @@ChFound            ; No, go to a higher order
                                             ; context
                                             ;Get Char positions in contexts
                                             ;2,4,6
@@GetChNbr:     mov     al,Char              ;
                xor     ah,ah                ;
                mov     ChNbr[02],ax         ;For context 2 Char
                                             ; is equal to Char position
                mov     bx,04                ;Shift to context 4
                                             ;Find Char position for
                                             ;contexts 4,6
@@FndNxt:       mov     si,CntxInd[bx]       ;Get Context Index
                add     si,si                ;
                mov     es,CntxIniSeg        ;
                mov     di, es:[si]          ;di points to start of context
                mov     dx,di                ;Save context beginning
                mov     cx,256d              ;Max size of context
                mov     es,DictSeg           ;
                repnz   scasb                ;Find Char in context
                sub      di,dx
                dec      di                  ;Get Char position
                mov     ChNbr[bx],di         ;Save Char position
                add     bx,02                ;Increment context number
                cmp     bx,MaxCntx           ;Are contexts 4,6 processed?
                jb      @@FndNxt             ; If not, go to the next

                mov     bx,MaxCntx-02        ;
even
@@l1:           mov     si,CntxInd[bx]       ;Get context index
                mov     PrevCntxInd[bx],si   ;Save context index
                add     si,si                ;
                mov     es,CntxIniSeg        ;
                mov     si,es:[si]           ;Get context beginning
                mov     ax,ChNbr[bx]         ;Get Char position and
                mov     PrevChNbr[bx],ax     ; save it
                add     si,ax                ;Calculate corresponding to
                add     si,si                ; Char address in Links
                mov     es,LinksSeg          ;
                mov     ax,es:[si]           ;Predict new context index
                mov     CntxInd[bx+02],ax    ; and save it
                sub     bx,02                ;Go to a lower order
                jnz     @@l1                 ; context

                jmp     @@NxtByte            ; Get next character to encode
BtRdd           dw      ?
BtTot           dw      ?
PackBlk         endp

;Frequency scale
FrScale         proc    near
                mov     si,CntxInd[bx]       ;Get context index
                add     si,si                ;
                mov     es,CntxSzSeg         ;
                mov     cx, es:[si]          ;Get Size of context
                inc     cx                   ;Get number of chars
                mov     es, CntxIniSeg       ;
                mov     si, es:[si]          ;Get context start
                mov     es,FreqSeg           ;
@@NxtFrq:       shr .b  es:[si],1            ;Divide frequency by 2
                inc     si                   ;Shift to the next frequency
                dec     cx                   ;All frequencies processed?
                jnz     @@NxtFrq             ; If no, scale next frequency
                ret                          ;  If yes, exit
FrScale         endp



;Return codes:
; NotCntd    - Char found, but all frequencies are equal 0
;              Char found, Char frequency is equal 0
; NotFnd     - Char not found
; Found      - Char found, Char frequency is not equal 0
even
;Try to find the Char in a given context
FindMatch       proc near
                mov     si,CntxInd[bx]   ;Get context index
                add     si,si            ;Get and save pointer to
                mov     bx,si            ; info about context
                mov     es,CntxIniSeg    ;
                mov     si,es:[bx]       ;Get start of context and
                mov     IniOfCntx,si     ; save it
                mov     es,CntxSzSeg     ;
                mov     cx,es:[bx]       ;Get context size
                add     si,cx            ;si points to the end of context
                inc     cx               ;Get Number of chars in context
                mov     NofLet,cx        ;Save it
@@CntxSrch:     xor     ax,ax            ;
                xor     dx,dx            ;
                mov     dh,Char          ;
                les     bx,.d ElimOffs   ;es=ElimSeg, bx=00
                push    ds               ;
                lds     di,.d DictOffs   ;ds=DictSeg, di=00

even
@@l1:           mov     bl,[si]          ;Get character
                dec     si               ;si points to the next character
                cmp     dh,bl            ;Char found?
                jz      @@ChFound        ; If so, go out..
                mov     al,es:[bx]       ;Recode, using Elim
                and     al,[si+8001h]    ;Get frequensy
                jz      @@NullFr1        ; If zero, skip
                inc     dx               ;(Number of non-zero frequencies)++
                add     di,ax            ;Get cumulative frequency
@@NullFr1:      dec     cx               ;All symbols processed?
                jnz     @@l1              ; If no, go to next..
                                         ;Char not found
@@ChNotFnd:     pop     ds               ;
                mov     LCnt,di          ;
                mov .w  RtCode,NotFnd    ;
                xor     dh,dh            ;Remove Char from dx
                add     di,dx            ;Calculate Scale
                test    di,0001h         ;If Scale is
                jz      @@NoAdj          ;  even and
                cmp     dx,01            ;   dx is
                jz      @@NoAdj          ;  greater 1,
                dec     di               ;   decrement Scale

@@NoAdj:        cmp     di,3fffh         ;If Scale is not too big,
                jb      @@SweepIni       ; not adjust frequencies,
                call    FrAdjP           ;  else knock down all frequencies
                jmp .s  @@CntxSrch       ; and calculate Scale again
@@SweepIni:     mov     Scale,di         ;
                jmp     @@CharsSweep     ;
                                         ;Char found,
@@ChFound:      mov     cs:ChPoz,si      ; save its position
                mov     al,[si+8001h]    ;Get frequency of Char
                cmp     ah,al            ;If frequency is not zero,
                adc     dx,00            ; increment counter
                mov     cs:CumFrExc,di   ;
                add     di,ax            ;
                mov     cs:CumFrInc,di   ;
                dec     cx               ;
                jz      @@PrpToEnc       ; Prepare to coding

even
@@l2:           mov     bl,[si]          ;Get character
                dec     si               ;si points to next character
                mov     al,.b es:[bx]    ;Recode, using Elim
                and     al,.b [si+8001h] ;Get frequency
                jz      @@NullFr2        ; If zero, skip
                inc     dx               ;   else increment counter
                add     di,ax            ;Increment cumulative frequency
@@NullFr2:      dec     cx               ;All symbols processed?
                jnz     @@l2             ; If no, go to next..
even                                     ;Prepare to encoding
@@PrpToEnc:     pop     ds               ;
                mov     LCnt,di          ;
                mov     si,CntxNmb       ;If context is 0,
                or      si,si            ;  no adjust
                jz      @@NoAdj1         ; Scale
                mov     ax,ChPoz         ;Save the
                inc     ax               ; position of a
                mov     FrAddr[si],ax    ; found Char
                sub     dh,Char          ;Remove Char from the sum
                add     di,dx            ;Get Scale
                or      dx,dx            ;If context is empty, exit
                jnz     @@DiAdj1         ;  else adjust Scale
                mov     ax,NotCntd       ;Context is empty, Char found
                ret                      ;

@@DiAdj1:       test    di,0001h         ;If Scale is
                jz      @@NoAdj1         ;  even and
                cmp     dx,01            ;   dx is
                jz      @@NoAdj1         ;  greater 1,
                dec     di               ;   decrement Scale
@@NoAdj1:       cmp     di,3fffh         ; If Scale is not too big,
                jb      @@NoAdjFr        ; not adjust frequencies,
                call    FrAdjP           ;  else knock down all
                jmp     @@CntxSrch       ; frequencies and calculate
                                         ;  Scale again
@@NoAdjFr:      mov     Scale,di         ;
                mov     RtCode,NotCntd   ;
                mov     ax,CumFrExc      ; If CumFrExc is equal
                cmp     ax,CumFrInc      ;    CumFrInc,
                jz      @@CharsSweep     ;   Char has zero frequency
                mov     LCnt,ax          ;
                mov     ax,CumFrInc      ;
                mov     HCnt,ax          ;
                mov .w  RtCode,Found     ;
                jmp .s  EncodeSymbol     ;
                                         ;If Char has zero frequency or not
                                         ; found, all chars in context are
                                         ; marked as 'chars-having-zero-
                                         ; frequency' and they are not counted,
                                         ; when we drop to a lower-order context
@@CharsSweep:   mov     HCnt,di          ;
                mov     cx, NofLet       ;
                xor     bx,bx            ;
                mov     di,ElimPnt       ;
                push    ds               ;
                mov     si,IniOfCntx     ;ds:si points to beginning
                mov     ds,DictSeg       ; of context

even
@@NxtFreq:      cmp .b  [si+8000h],00    ;Is frequency a zero?
                jz      @@SkipZFr        ;  Yes, skip it
                mov     bl,[si]          ;Get character
                cmp .b  es:[bx],00       ;Is character marked?
                jz      @@SkipZFr        ; If so, skip it
                mov     es:[di],bl       ;  else add it to Elim
                mov .b  es:[bx],bh       ;Zero out old position in Elim
                inc     di               ;di points to the next free position
@@SkipZFr:      inc     si               ;si points to the next char
                dec     cx               ; All symbols processed?
                jnz     @@NxtFreq        ; If no, go to the next..

                pop     ds               ;
                mov     ElimPnt,di       ;

even                                  ;Rescale High and Low to the new
                                      ;character
EncodeSymbol:   mov     ax,High       ;
                mov     bx,Low        ;bx=Low
                mov     cx,ax         ;Store High
                sub     ax,bx         ;ax=High-Low=Range
                mov     si,ax         ;si=Range
                mov     di,HCnt       ;
                cmp     di,Scale      ;
                jz      @@HiNoUpd      ; No update High
                mul     di            ;dx:ax=HCnt*Range
                add     ax,di         ;
                adc     dx,00         ;dx:ax=HCnt*Range+HCnt
                div     Scale         ;ax=(HCnt*Range+HCnt)/Scale
                add     ax,bx         ;Low+(HCnt*Range+HCnt)/Scale
                dec     ax            ;Low+(HCnt*Range+HCnt)/Scale-1
                mov     cx,ax         ;cx = new value of High

@@HiNoUpd:      mov     di,LCnt       ;
                or      di,di         ;
                jz      @@LowNoUpd    ; No update Low
                mov     ax,si         ;ax=Range
                mul     di            ;dx:ax=LCnt*Range
                add     ax,di         ;
                adc     dx,00         ;dx:ax=LCnt*Range + LCnt
                div     Scale         ;ax=(LCnt*Range+LCnt)/Scale
                add     bx,ax         ;bx=Low(old)+(LCnt*Range+LCnt)/Scale
                                      ;So bx and cx are new values of Low,
                                      ; High
@@LowNoUpd:     mov     si,UFlBits    ;
                mov     ah,BToSave    ;

even
@@NxtBit:       mov     al,bh         ;al=LowNewH
                xor     al,ch         ;Are top bits of Low and High match?
                js      @@Test2thBit  ; No, check underflow condition
                shl     bx,01         ;Yes, top bit can be send to the output
                rcl     ah,01         ;Save top bit into ah
                shr     BitCnt,1      ;Enough to fill one byte?
                jnz     @@UflBCheck   ; No, check UflBits
                call    SaveByte      ;Yes, save byte
@@UflBCheck:    or      si,si         ;Is UFlBits equal 0?
                jz      @@HighAdj     ; If so, shift High and check next bits
@@NxtUflBit:    cmp     ch,80h        ;If not, negate top bit in High
                adc     ah,ah         ; and pull it in
                shr     BitCnt,1      ;Enough to fill one byte?
                jnz     @@DecUflB     ; No, check UflBits
                call    SaveByte      ;Yes, save byte
@@DecUflB:      dec     si            ;Decrement UFlBits
                jnz     @@NxtUflBit   ;
@@HighAdj:      add     cx,cx         ;
                inc     cx            ;High=2*High+1
                jmp .s  @@NxtBit      ;

@@Test2thBit:   test    bh,40h        ;Is bit 14 in Low equal 1?
                jz      @@Quit        ; No, exit
                test    ch,40h        ;Is bit 14 in High equal 0?
                jnz     @@Quit        ; No, exit
                inc     si            ;Increment UFlBits
                and     bx,3fffh      ;Set bit 14 in Low to 0
                or      cx,4000h      ;Set bit 14 in High to 1
                add     bx,bx         ;Shift bx left
                add     cx,cx         ;
                inc     cx            ;High=2*High +1
                jmp.s   @@Test2thBit  ; Test next bit

@@Quit:         mov     BToSave,ah    ;
                mov     UFlBits,si    ;Save UFlBits
                mov     Low,bx        ;Save new values of
                mov     High,cx       ; High and
                mov     ax,RtCode     ; Low
                ret                   ;
CumFrExc        dw      ?
CumFrInc        dw      ?
NofLet          dw      ?
IniOfCntx       dw      ?
ChPoz           dw      ?
RtCode          dw      ?
FindMatch       endp


;Adjust frequencies when packing
FrAdjP          proc    near
                mov     si,IniOfCntx   ;
                mov     cx,NofLet      ;
                mov     es,FreqSeg     ;
@@NxtFreq:      shr .b  es:[si],1      ;Divide a frequency by 2
                inc     si             ;Go to the
                loop    @@NxtFreq      ; next frequency
                mov     cx,Noflet      ;
                dec     si             ;si points now to the end of context
                ret
FrAdjP          endp



even
;On input: ah -packed byte
SaveByte        proc    near
                mov     BitCnt,80h              ;
                mov     di,PackOffs             ;
                mov     PackBuff[di],ah         ;
                inc     di                      ;
                sub     ax,ax                   ;
                add     OutCntL,01              ;
                adc     OutCntH,ax              ;
                mov     PackOffs,di             ;
                cmp     di,PackBSize            ;Is buffer full?
                jz      @@Save                  ; Yes, save it
                ret                             ;No, continue packing
@@Save:         mov     PackOffs,ax
                pusha                           ;
                Write   WHandle,PackBSize,PackBuff ;Write packed block
                call    StatDisp                ;
                popa                            ;
                ret
SaveByte        endp




;Output significant bits left in the High and Low registers
FlushEncoder    proc near
                mov     ax,Low
                and     ax,4000h                ;Save bit 14
                call    SaveBit                 ; of Low
                add     UFlBits,10h             ;
@@NxtBit:       mov     ax,Low                  ;
                not     ax                      ;Negate bit 14 in Low and
                and     ax,4000h                ; save UflBits+16d bits
                call    SaveBit                 ;
                dec     UFlBits                 ;
                jz      @@Quit                  ;
                jmp .s  @@NxtBit                ;
@@Quit:         ret
FlushEncoder    endp


SaveBit         proc near
                cmp     al,ah                   ;
                rcl     BToSave,01              ;Pull in bit 14 of Low
                shr     BitCnt,01               ;Enough to fill one byte?
                jnz     @@Quit                  ; No, exit
                                                ;Yes,save byte
                add .w  OutCntL,01              ;Increment the counter of
                adc .w  OutCntH,00              ; packed bytes
                mov     BitCnt,80h              ;Reset packed bits counter
                mov     al,BToSave              ;
                mov     si,PackOffs             ;si points to free place
                mov     PackBuff[si],al         ;Save byte in PackBuff
                inc     PackOffs                ;
                cmp     PackOffs,PackBSize      ;Is buffer full?
                jnz     @@BuffNFull             ; No, zero BTosave and exit
                Write   WHandle,PackBSize,PackBuff ;Yes, write it to file
                mov     PackOffs,00             ;PackBuff is empty now
@@BuffNFull:    mov     si,PackOffs             ;
                mov .b  PackBuff[si],00         ;
                mov .b  BToSave,00              ;
@@Quit:         ret                             ;
SaveBit         endp


;Write the rest of packed file
WrRest          proc near
                mov     cx,PackOffs             ;
                inc     cx                      ;Number of bytes to write
                Write   WHandle,cx,PackBuff     ;
                add     OutCntL,56d             ;Add header
                adc     OutCntH,00              ; length
                call    StatDisp                ;Display total file length
                Message Ok                      ;
                ret                             ;
WrRest          endp

;Prepare files to unpacking
FPrep           proc     near
                Open     FNameW          ;Open archive file
                mov      bx,ax           ;
                mov      WHandle,ax      ;Store handle
                Read     ,16d,PackBuff   ;Do the read of 16 bytes
                push     cs              ;
                pop      es              ;Restore ES
                mov      cx,16d          ;
                mov      si,.o PackBuff  ;
                mov      di,.o FstHdrRow ;
                repe     cmpsb           ;It is really HAP archive?
                jz       @@ItIsArch      ; It seems to be true ..
                mov      si,.o FNameW    ;No, it is NOT HAP archive..
                call     GetName         ;
                Message  PName           ;Display archive name
                Quit     IsNHap          ;Quit to DOS
@@ItIsArch:     mov      bx,WHandle
                FSeek    00,<xor cx,cx>,<mov dx,32d>
                Read      ,22d,Attrib   ;Read Attribute,Time,Date
                                        ; Size,Name and
                                        ; move file pointer to the packed data
                FSeek    00,<xor cx,cx>,<mov dx,54d>
                Read     ,01,PFlag      ;
                Create   FNameR,00      ;Create file for unpacked data
                mov      RHandle,ax     ;Save handle
                cmp      PFlag,16h      ;Was file packed or stored?
                jz       @@Exit         ;If it was packed, go out
                                        ;If it was stored, copy file to desti-
                                        ; nation and go to DOS
@@NxtBl:        Read     WHandle,InpBSize,ReadBuff
                cmp      ax,InpBSize
                jnz      @@UnpRmnd
                Write    RHandle,InpBSize,ReadBuff
                jmp .s   @@NxtBl
@@UnpRmnd:      cmp      ax,00          ;All down?
                jz       @@Quit         ;If so, display message and exit
                push     ax             ;If no, write remainder
                Read     WHandle,ax,ReadBuff
                pop      ax             ;Restore remainder size
                Write    RHandle,ax,ReadBuff
@@Quit:         Quit     Ok
@@Exit:         ret
FPrep           endp

;Prepare to unpacking
PrepToDec       proc near
                mov     Low,00              ;Set up initial values of
                mov     High,0ffffh         ; Low and High
@@Prep:         Read    WHandle,02,PackBuff ;Read first two bytes
                mov     di,.o PackBuff
                sub     ax,ax               ;
                mov     BitCnt,al           ;Reset counter of packed bits
                dec     ax                  ;
                mov     DecBCnt,ax          ;Set counter of decoded bytes
                mov     ax,[di]             ;Get first two bytes and
                xchg    ah,al               ; place them in reverse order
                mov     Value,ax            ;Now we have first word to decode
                mov     InCntL,02           ;Two bytes are read
                mov     InCntH,00           ; already
                ret                         ;
PrepToDec       endp


;Recreate file
FUnPack         proc near
                mov     OutBCnt,00              ;
                sub     ax,ax                   ;
                mov     InCntL,ax               ;Reset the counter
                mov     InCntH,ax               ;of input bytes
                mov     OutCntL,ax              ;Reset the counter
                mov     OutCntH,ax              ;of output bytes

@@NxtChUnp:     mov     CntxNmb,MaxCntx         ;
                mov     cx,ElimPnt              ;
                mov     si,100h                 ;
                sub     cx,si                   ;
                jz      @@ExCntxFnd             ; If Elim not changed,
                                                ;   find existing context
                mov     es,ElimSeg              ;   else restore Elim
                sub     bh,bh                   ;
@@NxtRest:      mov     bl,.b es:[si]           ;
                dec .b  es:[bx]
                inc     si                      ;
                loop    @@NxtRest               ;
                mov     ElimPnt,100h            ;
                                                ;Find first existing context
@@ExCntxFnd:    mov     bx,CntxNmb              ;
                cmp     CntxInd[bx],NotUsed     ;Is context exist?
                jnz     @@SymDec                ; If so, try to decode
                mov     CntxStat[bx],NotUsed    ;If no, mark as not-existing
                sub     Cntxnmb,02              ;
                jmp .s  @@ExCntxFnd             ; Check lower order context

@@SymDec:       call    DecodeSymbol            ;Try to decode character
                or      ax,ax                   ;Is character decoded?
                jz      @@ChSave                ; Yes, save it and
                                                ;   process current and
                                                ;   higher order contexts
                cmp     ax,Hollow               ;Are all frequencies=0?
                jz      @@SaveStat              ; Yes,don't remove character
                call    RemoveSymbol            ;Remove decoded character
@@SaveStat:     mov     bx,CntxNmb              ;
                mov     CntxStat[bx],NotCntd    ;
                sub     CntxNmb,02
                jmp .s  @@SymDec                ; Go to lower order context

@@ChSave:       call    RemoveSymbol            ;Remove character
                mov     bx,CntxNmb              ;
                mov     CntxStat[bx],Found      ;Character found in context bx
                call    SaveChar                ;Save unpacked character
                cmp     CntxNmb,MaxCntx         ;Are all contexts processed?
                jz      @@FndChNbr              ;Yes,get current Char position
                                                ;Depending on the context
                                                ;status add symbol to context
even                                            ;or create new one
@@ToLeaf:       mov     bx,CntxNmb              ;
                cmp     CntxStat[bx],NotCntd    ;
                jnz     @@StatIsClear           ; Context status is clear
                call    SpecCntxStat            ;Specify the context status
even
@@StatIsClear:  mov     bx,CntxNmb              ;
                mov     ax,CntxStat[bx]         ;
                cmp     ax,NotUsed              ;Is context exist?
                jz      @@CntxCreate            ; No, - create new context
                cmp     ax,NotFnd               ;Is character not found?
                jz      @@AddChar               ; Yes, add character
                jmp .s  @@NxtCntx               ; Go to the higher order
even                                            ;  context
@@AddChar:      call    AddToCntx               ;Add character to context
                cmp     ax,-1                   ;
                jz      @@CdrIni                ;
                jmp .s  @@NxtCntx               ;
even
@@CntxCreate:   call    CreateCntx              ;Create new context
                cmp     ax,0ffffh               ;
                jnz     @@NewCntxLinks          ;

@@CdrIni:       call    CoderIni                ;
                jmp     @@IsCmpltd              ;
                                                ;
@@NewCntxLinks: mov     bx,CntxNmb              ;
                mov     CntxInd[bx],ax          ;
                mov     es,CntxIniSeg           ;
                mov     si,PrevCntxInd[bx-02]   ;
                add     si,si                   ;Get the beginning of
                mov     si,es:[si]              ; previous context
                add     si,PrevChNbr[bx-02]     ;Add previous char position
                mov     es,LinksSeg             ;Link new
                add     si,si                   ; context
                mov     es:[si],ax              ; to the previous one
even
@@NxtCntx:      add     CntxNmb,02
                cmp     CntxNmb,MaxCntx         ;Are all contexts processed?
                jna     @@ToLeaf                ; No, go to a higher order context
even                                            ; Yes, get current Char position
@@FndChNbr:     mov     al,Char                 ;
                xor     ah,ah                   ;
                mov     ChNbr[02],ax            ;For context 2 Char
                                                ; is equal to Char position
                mov     bx,0004h                ;
@@NxtChNbr:     mov     si,CntxInd[bx]          ;
                add     si,si                   ;
                mov     es,CntxIniSeg           ;
                mov     di,es:[si]              ;Context beginning
                mov     dx ,di                  ;
                mov     cx,256d                 ;Max length of context
                mov     es,DictSeg              ;
                repnz   scasb                   ;Find Char in context              饬 室 ᨬ
                sub     di,dx                   ;
                dec     di                      ;Get Char position                   ᨬ
                mov .w  ChNbr[bx],di            ;Save Char position                  ᨬ
                add     bx,02                   ;Shift to a higher order context
                cmp     bx,MaxCntx              ;Are contexts 4,6 processed? ?      ⥪ ᬮ५?
                jb      @@NxtChNbr              ; If not, go to the next           -   ᫥饬

                mov     di,LinksSeg             ;
                mov     dx,CntxIniSeg           ;
                mov     bx,MaxCntx-02           ;
                mov     cx,NofCntx-02           ;
@@NxtPred:      mov     si,CntxInd[bx]          ;
                mov     PrevCntxInd[bx],si      ;
                add     si,si                   ;
                mov     es,dx                   ;
                mov     si, es:[si]             ; Get context beginning
                mov     ax,ChNbr[bx]            ; Get Char position and
                mov     PrevChNbr[bx],ax        ;  save it
                add     si,ax                   ; Calculate corresponding to
                add     si,si                   ;  Char address in Links
                mov     es,di                   ;
                mov     ax,es:[si]              ; Predict new context index
                mov     CntxInd[bx+02],ax       ;  and save it
                sub     bx,02                   ; Go to the lower order
                loop    @@NxtPred               ;  context

@@IsCmpltd:     mov     ax,OutFSzH              ;Are all characters
                or      ax,OutFSzL              ;unpacked?
                jz      @@Upackcmpl             ; Yes, stop unpacking
                jmp     @@NxtChUnp              ; No, unpack next character

@@Upackcmpl:    cmp     OutBCnt,00              ;Is output buffer empty?
                jz      @@Exit                  ; Yes, go out
                Write   RHandle,OutBCnt,ReadBuff;Write the rest of buffer
                call    StatDisp                ;Print out the number of
                                                ; input and output bytes
                Message Ok                      ;
@@Exit:         ret                             ;
FUnPack         endp

;Save unpacked character
even
SaveChar        proc    near
                mov     al,Char                 ;
                mov     si,OutBCnt              ;
                mov     ReadBuff[si],al         ;Save unpacked character
                inc     OutBCnt                 ;
                cmp     OutBCnt,InpBSize        ;Is buffer full?
                jb      @@BuffNFull              ; No, continue unpacking
                Write   RHandle,InpBSize,ReadBuff;Yes, write buffer to file
                call    StatDisp                ;
                mov     OutBCnt,0000h           ;
@@BuffNFull:    add     OutCntL,01              ;Increment counter of
                adc     OutCntH,00              ; unpacked bytes
                sub     OutFSzL,01              ;Decrement number of
                sbb     OutFSzH,00              ; input bytes
                ret
SaveChar        endp

;Prints out the number of input and the number of output bytes
StatDisp        proc     near
                mov      di,.o Digit
                mov      dx,InCntH             ;
                mov      ax,InCntL             ;
                call     DwToAscii             ;Convert DWord to ASCII string
                mov .b   [di],' '
                mov .b   [di+1],'$'
                mov      di,.o Digit1
                mov      dx,OutCntH
                mov      ax,OutCntL
                call     DwToAscii             ;Convert to ASCII string
                                               ;the counter of output bytes
                mov .b   [di],' '
                mov .b   [di+1],CR
                mov .b   [di+2],'$'
                cmp      Encode,00
                jz       @@UnpMsg              ;
                Message  Packing
                jmp .s   @@NoMoMsgs            ;
@@UnpMsg:       Message  UnPacking
@@NoMoMsgs:     mov      si,.o FNameR
                call     GetName
                Message  PName         ;Print out the name of file
                Message  Digit         ;Print out the number of input bytes
                Message  Arrow         ; '=>'
                Message  Digit1        ;Print out the number of output bytes
                ret
StatDisp        endp


;Return codes:
;    Hollow  - all frequecies are equal 0
;    NotCntd - frequency of character is equal 0
;    Found   - character found
even
DecodeSymbol    proc near
                push    ds                    ;
                mov     bx,CntxNmb            ;
                mov     di,CntxInd[bx]        ;
                add     di,di                 ;Pointer to context information
                mov     es,CntxSzSeg          ;
                mov     cx,es:[di]            ;Get context size
                mov     es,CntxIniSeg         ;
                mov     si,es:[di]            ;Get context beginning
                mov     CntxIni[bx],si        ;Save context
                mov     IniOfCntx,si          ; beginning
                add     si,cx                 ;Get address of context end
                inc     cx                    ;Get number of characters
                mov     ChNbr1,cx             ;Save number of
                mov     CntxSize[bx],cx       ; characters
                                              ;Get cumulative frequencies
@@GetCumFrq:    mov     es,ElimSeg            ;
                xor     ax,ax                 ;Reset
                xor     dx,dx                 ; counters
                xor     di,di                 ;Zero out cumulative frequency
                mov     DsTmp,ds              ;
                mov     ds,DictSeg            ;
even                                          ;
@@NxtCh:        push    di                    ;Push cumulative frequency
                mov     bl,[si]               ;Get character
                dec     si                    ;si points to next character
                mov     al,es:[bx]            ;Recode, using Elim
                and     al,[si+8001h]         ;Get frequensy
                jz      @@NullFr              ; If zero, skip
                inc     dx                    ;Increment number of non-zero frequencies
                add     di,ax                 ;Get cumulative frequency
@@NullFr:       dec     cx                    ;All symbols processed?
                jnz     @@NxtCh               ; If no, go to the next..
                push    di                    ;Push last cumulative frequency

                or      di,di                 ;Are all frequencies =0?
                jnz     @@CntxNEpt            ; No, continue decoding
                mov     ax,Hollow             ;Yes, exit
                jmp     @@Exit                ;

@@CntxNEpt:     mov     ds,cs:DsTmp           ;
                cmp     CntxNmb,00            ;If context number is zero,
                jnz     @@ScaleAdj            ;  not adjust scale
                jmp .s  @@GetChar             ; and go to Char decoding

@@ScaleAdj:     add     di,dx                 ;
                test    di,01                 ;If Scale is
                jz      @@NoAdj               ;  even and
                cmp     dx,01                 ;   dx is
                jz      @@NoADj               ;  greater 1,
                dec     di                    ;   decrement Scale

@@NoAdj:        cmp     di,3fffh              ; If Scale is not too big,
                jb      @@GetChar             ; not adjust frequencies,
                call    FrAdjUp               ;  else knock down all
                jmp .s  @@GetCumFrq           ; frequencies and calculate
                                              ;   Scale again

even                                          ;Start of Char decoding
@@GetChar:      push    di                    ;Save Scale
                mov     Scale,di              ;
                mov     ax,Value              ;
                sub     ax,Low                ;Value-Low
                inc     ax                    ;Value-Low+1
                jnz     @@MulScale            ; If ax=10000h,
                mov     dx,di                 ; multiply
                dec     dx                    ; without
                dec     ax                    ; mul; dx:ax=Scale*(Value-Low+1)
                jmp .s  @@NoMul               ;

@@MulScale:     mul     di                    ;dx:ax=Scale*(Value-Low+1)
                sub     ax,0001h              ;Substract
                sbb     dx,00                 ; one

@@NoMul:        mov     bx,High               ;
                sub     bx,Low                ;bx=Range=High-Low
                inc     bx                    ;bx=Range+1
                jnz     @@GetCumFr            ; If result = 10000h,
                                              ;  divide
                mov     ax,dx                 ;  without div
                jmp .s  @@FndChar             ;
                                              ;
@@GetCumFr:     div     bx                    ;Scale*(Value-Low+1)/(Range+1)
@@FndChar:      cld                           ;
                mov     bx,ss                 ;
                mov     es,bx                 ;
                mov     di,sp                 ;es:di points now to Scale
                xor     cx,cx                 ;
@@NxtCmp:       inc     cx                    ;Increment frequencies counter
                scasw                         ;Is cumulative frequency found?
                jb      @@NxtCmp              ; No, try next frequency
                sub     di,04                 ;Yes, di points to HCnt
                mov     ax,es:[di+02]         ;
                mov     bx,es:[di]            ;
                mov     HCnt,bx               ;Get HCnt and
                mov     LCnt,ax               ; LCnt
                cmp     di,sp                 ;If HCnt is equal to Scale, then
                jz      @@CharsSweep          ; it  was  ESC symbol
                sub     cx,03                 ;
                mov     bx,CntxNmb            ;
                add     cx,IniOfCntx          ;
                mov     bx,cx                 ;
                mov     es,DictSeg            ;
                mov     al,es:[bx]            ;
                mov     Char,al               ;At last Char decoded!
                mov     ds,FreqSeg            ;
                cmp .b  [bx],0ffh             ;Is Frequesy=MaxFrequensy?
                jnz     @@FrInc               ; No, increment frequency
                mov     cx,cs:ChNbr1          ;
                mov     di,cs:IniOfCntx       ;Yes, knock down
@@ScaleNxt:     shr .b  [di],1                ; all
                inc     di                    ; frequencies
                loop    @@ScaleNxt            ;

@@FrInc:        inc .b  [bx]                  ;
                mov     ax,Found              ;Return code
                jmp .s  @@SPRest              ; Restore stack and exit

                                              ;
@@CharsSweep:   xor     bx,bx                 ;
                mov     di,ElimPnt            ;di 㪠.  ᢮.  ElimSeg
                mov     dx,ds                 ;
                mov     cx,ChNbr1             ;Number of chars in context
                mov     si,IniOfCntx          ;Get context beginning
                mov     es,ElimSeg            ;
                mov     ds,DictSeg            ;
even
@@NxtFr:        cmp .b  [si+8000h],00         ;Is frequency a zero?
                jz      @@ChSkip              ; Yes, skip it
                mov     bl,[si]               ;Get character
                cmp .b  es:[bx],00            ;Is character marked?
                jz      @@ChSkip              ; If so, skip it

                mov     es:[di],bl            ; else add it to Elim
                mov .b  es:[bx],bh            ;Zero out old position in Elim
                inc     di                    ;di points to the next free position
@@ChSkip:       inc     si                    ;si points to the next char
                dec     cx                    ;All symbols processed?
                jnz     @@NxtFr               ; If no, go to the next

                mov     ds,dx                 ;
                mov     ElimPnt,di            ;
                mov     ax,NotCntd            ;
@@SPRest:       mov     di,01                 ;
@@Exit:         add     di,cs:ChNbr1          ;
                inc     di                    ;
                add     di,di                 ;Restore stack
                add     sp,di                 ; before returning
                pop     ds                    ;Restore ds
                ret                           ;
DsTmp           dw      ?
DecodeSymbol    endp

;Specify context status
SpecCntxStat    proc near
                cld                             ;
                mov     bx,CntxNmb              ;
                mov     es,DictSeg              ;
                mov     cx,CntxSize[bx]         ;Get size and
                mov     di,CntxIni[bx]          ; beginning of context
                mov     al,Char                 ;
                repnz   scasb                   ;Look for Char
                jnz     @@Quit                  ; If Char not found, exit
                inc .b  es:[di+7fffh]           ;Char found, increment
                mov     CntxStat[bx],Found      ; frequency and exit
                ret                             ;
@@Quit:         mov     CntxStat[bx],NotFnd     ;
                ret                             ;
SpecCntxStat    endp

;After the character has been decoded, remove it from the input stream
even
RemoveSymbol    proc near
                mov     ax,High                 ;
                mov     bx,Low                  ;
                mov     cx,ax                   ;Store High
                sub     ax,bx                   ;ax=High-Low=Range
                mov     si,ax                   ;si=Range
                mov     di,HCnt                 ;If HCnt is equal
                cmp     di,Scale                ;  to Scale, not
                jz      @@HNUpd                 ; update High

                mul     di                      ;dx:ax=HCnt*Range
                add     ax,di                   ;
                adc     dx,00                   ;dx:ax=HCnt*Range+HCnt
                div     Scale                   ;ax=(HCnt*Range+HCnt)/Scale
                add     ax,bx                   ;Low+(HCnt*Range+HCnt)/Scale
                dec     ax                      ;Low+(HCnt*Range+HCnt)/Scale-1
                mov     cx,ax                   ;cx=new value of High
@@HNUpd:        mov     di,LCnt                 ;If LCnt is equal to zero,
                or      di,di                   ; not update Low
                jz      @@LNUpd                 ;
                mov     ax,si                   ;ax=Range
                mul     di                      ;dx:ax=LCnt*Range
                add     ax,di                   ;
                adc     dx,00                   ;dx:ax=LCnt*Range + LCnt
                div     Scale                   ;ax=(LCnt*Range + LCnt)/Scale
                add     bx,ax                   ;So bx and cx are new values
                                                ; of Low, High
@@LNUpd:        mov     ah,ch                   ;
                xor     ah,bh                   ;If top bits of Low and High
                jns     @@ShifOut               ; match, shift top bit out
                test    ch,40h                  ;Check for underflow
                jnz     @@SaveBords             ; If no danger, save Low,High
                mov     ah,bh                   ;
                and     ah,40h                  ; Next check for underflow
                jz      @@SaveBords             ; If no danger, save Low,High
                                                ;If underflow is threatening,
                xor .b  Value[01],ah            ; reverse bit 14 in Value,
                or      ch,ah                   ; set bit 14 in High,
                and     bh,3fh                  ; mask off bit 14 in Low
@@ShifOut:      add     bx,bx                   ;Low=Low*2
                add     cx,cx                   ;
                inc     cx                      ;High=High*2+1
                cmp     BitCnt,00               ;Are all bits processed?
                jnz     @@PullBit               ; No, pull in next bit
                call    ReadByte                ;Yes, read next byte
@@PullBit:      dec     BitCnt                  ;
                shl     ByteRdd,1               ;Next bit is in CF now,
                rcl     Value,1                 ; push it in Value
                jmp     @@LNUpd                 ;

@@SaveBords:    mov     Low,bx                  ;Save new values of Low
                mov     High,cx                 ; and High
                ret                             ;
RemoveSymbol    endp

;Adjust frequencies when unpacking
FrAdjUp         proc    near
                mov     es,FreqSeg   ;
                mov     cx,ChNbr1    ;
                mov     si,IniOfCntx ;
                add     sp,cx        ;Restore
                add     sp,cx        ; stack
@@NxtFreq:      shr .b  es:[si],1    ;Divide frequency by 2
                inc     si           ;
                loop    @@NxtFreq    ;
                dec     si           ;si points to the end of context
                mov     cx,ChNbr1    ;
                ret
FrAdjUp         endp


even
ReadByte        proc    near
                mov     BitCnt,08             ;Reset the  counter of bits
                add     InCntL,01             ;Increment the counter of
                adc     InCntH,00             ; all input bytes
                mov     si,DecBCnt            ;
                cmp     si,0fffh              ;Are all bytes in block decoded?
                jbe     @@GetByte             ; No, get next byte
                pusha                         ;
                Read    WHandle,PackBSize,PackBuff;Read next block
                popa                          ;
                xor     si,si                 ;si points to the first byte
                mov .w  DecBCnt,si            ;Reset the counter of decoded
even                                          ;  bytes
@@GetByte:      mov     dl,PackBuff[si]       ;Get byte for unpacking and
                mov     ByteRdd,dl            ; save it
                inc     DecBCnt               ;Increment the counter of
                ret                           ; decoded bytes and return
ReadByte        endp



;Alocate memory for THap data structures
MemAlloc        proc near
                mov     ax,ss
                add     ax,21h
                xor     bx,bx             ;All Offsets are equal to 0
                mov     CntxSzOffs,bx     ;
                mov     CntxSzSeg,ax      ;
                add     ah,10h            ;64 k is occupied by CntxSz
                mov     CntxIniOffs,bx    ;
                mov     CntxIniSeg,ax     ;
                add     ah,10h            ;64 k is occupied by CntxIni
                mov     DictOffs,bx       ;
                mov     DictSeg,ax        ;
                add     ah,08             ;32 k is occupied by Dict
                mov     FreqOffs,bx       ;
                mov     FreqSeg,ax        ;
                add     ah,08             ;32 k is occupied by Freq
                mov     LinksOffs,bx      ;
                mov     LinksSeg,ax       ;
                add     ah,10h            ;64 k is occupied by Links
                mov     FrPlOffs,bx       ;
                mov     FrPlSeg,ax        ;
                add     ax,21h            ;528 bytes occupied by FrPl
                mov     ElimOffs,bx       ;
                mov     ElimSeg,ax        ;
                add     ax,25h            ;Add Elim size + a few bytes to give
                                          ; a guarantee
                cmp     ax,0a000h         ;Is available memory >= requested?
                ja      @@MemAllErr       ; If not, exit to Dos
                                          ;If so, initialize some variables
                mov     ax,bx             ;
                mov     Low,ax            ;
                mov     UFlBits,ax        ;
                mov     PackOffs,ax       ;
                mov     BToSave,al        ;
                mov     BitCnt,80h        ;
                dec     ax                ;
                mov     High,ax           ;
                ret                       ;
@@MemAllErr:    Quit    NoMem
MemAlloc        endp

;Initialize packer/unpacker data structures
CoderIni        proc near
                                          ;FrPl is a list of free
                                          ; places in Dict
                les     di,.d FrPlOffs    ;
                push    di                ;
                mov     cx,256d           ;
                mov     ax,-1             ;Mark all pieces in Dict as not free
                repz    stosw             ;
                mov .w  es:[di],0300h     ;256 bytes are free and 300h is
                                          ; the beginning of them in Dict
                pop     di                ;
                mov .w  es:[di+2],0203h   ;Single byte in Dict[203h] is free

                                          ;CntxSz is a list of context
                                          ; sizes. Number of letters is equal
                                          ; to size of context + 1
                les     di, .d CntxSzOffs ;
                mov     ax,00ffh          ;There are initially
                stosw                     ; two context (0,2) with
                stosw                     ; sizes 255d
                mov     al,ah             ; Zero out ax
                stosw                     ;Other three contexts (4,6,8)
                stosw                     ; have a zero
                stosw                     ; size
                                          ;
                                          ;CntxtIni contains context
                                          ; beginnings in Dict
                les     di,.d CntxIniOffs ;
                stosw                     ;The beginning of context 0 is 0
                inc     ah                ;
                stosw                     ;The beginning of context 2 is 100h
                inc     ah                ;
                stosw                     ;The beginning of context 4 is 200h
                inc     al                ;
                stosw                     ;The beginning of context 6 is 201h
                inc     al                ;
                stosw                     ;The beginning of context 8 is 202h
                                          ;
                                          ;So, there are five contexts:
                                          ;0,2,4,6,8. First two contain 256
                                          ;symbols each. They are fixed.
                                          ;Other three contexts contain ini-
                                          ;tially one character each.
                                          ;
                                          ;Dict contains all contexts
                les     di, .d DictOffs   ;
                mov     cx,512d           ;
                xor     ax,ax             ;
@@NxtCh:        stosb                     ;Contexts 0,2 contain all characters
                inc     al                ;from 0 to 0ffh
                loop    @@NxtCh           ;
                mov .b  es:[di],'h'       ;Context 4 contains one character
                mov .b  es:[di+1],'e'     ;Ditto context 6
                mov .b  es:[di+2],'e'     ;Ditto context 8
                                          ;
                                          ;Freq contains frequencies of
                                          ; characters
                les     di, .d FreqOffs   ;
                mov     cx,128d           ;
                mov     ax,0101h          ;All frequencies in context 0 are
                repz    stosw             ; are fixed and equal 1
                xor     ax,ax             ;All frequencies in context 2
                mov     cx,128d           ; are zero, but they will
                repz    stosw             ; be changed later
                stosw                     ;Frequencies in contexts 4,6,8 are
                stosb                     ; all zero
                                          ;
                                          ;Links contains tree of contexts,
                                          ; it also take part in memory
                                          ; managing
                les     di, .d LinksOffs  ;   Initial tree of contexts:
                mov     di,200h           ;
                mov     cx,256d           ;      2
                mov     ax,0ffffh         ;    Ŀ       4       6
                repz    stosw             ;     .      Ŀ    Ŀ
                mov .w  es:[2d0h],04      ;    't' --- 'h' ---'e'
                mov .w  es:[2e8h],02      ;     .          
                mov .w  es:[400h],03      ;     .      Ŀ
                mov .w  es:[402h],-1      ;    'h' ----'e'8
                mov .w  es:[404h],-1      ;     .      
                mov     cx,252d           ;    
                mov     di,0406h          ;
                mov     ax,0204h          ;
@@NxtFrBPoz:    stosw                     ;Save the list
                inc     ax                ; of free
                loop    @@NxtFrBPoz       ; bytes
                mov .w  es:[di],-1        ;Terminate the list of free bytes

                mov     di,0600h          ;
                mov     cx,007ch          ;
                mov     ax,0400h          ;
b0049f:         mov     es:[di],ax        ;Write the list
                add     di,0200h          ; of free
                add     ax,256d           ; 256-byte
                loop    b0049f            ; blocks
                mov .w  es:[di],-1        ;Terminate the list
                                          ;
                                          ;All 256 bytes in Elim are equal
                les     di,.d ElimOffs    ; initially to 0ffh
                cld                       ;
                xor     ax,ax             ;
                dec     ax                ;
                mov     cx,128d           ;
                repz    stosw             ;
                                          ;Reset some  variables and arrays
                mov     CntxIniPnt,0ah    ;Points to the last taken pozition
                                          ; in CntxIni,CntxSize
                sub     ax,ax             ;
                mov     CntxInd[0],ax     ;
                mov     CntxInd[2],01     ;
                dec     ax                ;
                mov     CntxInd[4],ax     ;
                mov     CntxInd[6],ax     ;
                mov     CntxInd[8],ax     ;
                inc     ax                ;
                mov     PrevCntxInd[02],01;
                mov     PrevCntxInd[04],03;
                mov     PrevCntxInd[06],04;

                mov     PrevChNbr[02],65h ;
                mov     PrevChNbr[04],ax  ;
                mov     PrevChNbr[06],ax  ;
                mov     ElimPnt,100h      ;
                ret                       ;
CoderIni        endp

even
;Create new context
CreateCntx      proc near
                mov     si,CntxIniPnt    ;si points to last taken position
                add     CntxIniPnt,02    ;Set pointer to first free position
                cmp     si,0ffffh        ;Are CntxIni,CntxSz already full?
                jnz     @@PlExist        ; If no, find free place for context
                mov     ax,si            ;If so, return and reset coder
                ret                      ;
                                         ;an attempt to find free byte
@@PlExist:      mov     es,FrPlSeg       ;FrPl contains free places in Dict
                mov     bx,es:[02]       ;If bx is not equal 0ffffh, it
                cmp     bx,0ffffh        ; points to the free byte in Dict
                jz      @@FndBgst        ;There are no free single bytes in
                                         ;  Dict, try to find 2 or more
                mov     al,Char          ;Save input character
                mov     es,DictSeg       ; in
                mov     es:[bx],al       ; Dict
                mov .b  es:[bx+8000],1   ;Initial frequency is equal 1
                mov     es,CntxIniSeg    ;
                mov     es:[si],bx       ;Save context beginning
                mov     es,CntxSzSeg     ;
                mov .w  es:[si],00       ;Save context size
                add     bx,bx            ;Get address in Links
                mov     es,LinksSeg      ;
                mov     ax,es:[bx]       ;New position of free byte in Dict
                mov .w  es:[bx],-1       ;New context has no links yet
                mov     es,FrPlSeg       ;
                mov     es:[02],ax       ;Store position of free byte in FrPl
                shr     si,1             ;
                mov     ax,si            ;Return context index
                ret
                                         ;An attempt to find more than 1 byte
@@FndBgst:      mov     di,04            ;di points to the next addr in FrPl
                mov     cx,00ffh         ;
                mov     ax,bx            ;ax=0ffffh
                cld                      ;es=FrPlSeg
                rep     scasw            ;Search for a free place
                jz      @@Exit           ; If free place is not found,
                                         ;return and reset coder
                sub     di,02            ;Scasw increments 2 too much
                mov     bx,es:[di]       ;Address of context beginning
                inc     bx               ;Now the free plase is
                mov     es:[di-02],bx    ; one byte right and one byte smaller
                dec     bx               ;Restore address of beginning
                mov     al,Char          ;Send the input character
                mov     es,DictSeg       ; to the new
                mov     es:[bx],al       ; context
                mov .b  es:[bx+8000],1   ;Initial frequency is equal 1
                mov     es,CntxIniSeg    ;
                mov     es:[si],bx       ;Save context beginning
                mov     es,CntxSzSeg     ;
                mov .w  es:[si],0000h    ;Save context size
                add     bx,bx            ;Get address in Links
                mov     es,LinksSeg      ;
                mov     ax,es:[bx]       ;New position of free byte in Dict
                mov .w  es:[bx],0ffffh   ;New context has no links yet
                mov .w  es:[bx+2],0ffffh ;Address will be placed in FrPl
                mov     es,FrPlSeg       ;
                mov     es:[di],ax       ;Save new position, if exist
                shr     si,1             ;
                mov     ax,si            ;
@@Exit:         ret                      ;
CreateCntx      endp

even
; Add character to the existing context
AddToCntx       proc near
                mov     bx,CntxNmb       ;Get context number
                mov     di,CntxInd[bx]   ;Get context index
                add     di,di            ;di points now to the information
                mov     CInfoOffs,di     ; on context size and beginning
                mov     es,CntxSzSeg     ;
                mov     dx,es:[di]       ;Get current size of context
                inc .w  es:[di]          ;Increment context size by one
                mov     cx,0ffh          ;Maximum context size
                sub     cx,dx            ;Decrement max size by current one
                add     dx,02            ;Try to find dx+2 or more
                add     dx,dx            ; free bytes
                mov     es,FrPlSeg       ;
                mov     di,dx            ;
                mov     ax,0ffffh        ;
                repz    scasw            ;Search for a free place
                jnz     @@FrPlExst       ; If exist, move context there
                ret                      ; else return

@@FrPlExst:     sub     di,02            ;Scasw increments 2 too much
                mov     si,es:[di]       ;si points now to the new beginning
                push    si               ;Save new beginning of context
                add     si,si            ;Links contains words, not bytes
                mov     es,LinksSeg      ;
                mov     bx,es:[si]       ;Get another address of a free
                mov     es,FrPlSeg       ; place and save it
                mov     es:[di],bx       ; in FrPl
                sub     di,dx            ;Is the size just the same as needed?
                jz      @@CntxMove       ;Yes, move context to the new place
                                         ;No, mark extra piece as free
                add     si,dx
                mov     ax,si            ;
                shr     ax,01            ;Beginning of an extra piece
                xchg    ax,es:[di]       ;Save it in FrFl and
                mov     es,LinksSeg      ; old content of FrPl
                mov     es:[si],ax       ; save in Links

@@CntxMove:     mov     bx,CInfoOffs     ;
                mov     cx,dx            ;
                shr     cx,01            ;
                dec     cx               ;New context size
                mov     es,CntxIniSeg    ;
                pop     si               ;Reset new beginning of context
                mov     di,si            ; and store it in di
                xchg    si,es:[bx]       ;Save new beginning and get old one
                mov     dx,si            ;Store old context beginning  *
                mov     bx,cx            ;Store new context size
                add     bx,bx            ;word address
                mov     es,FrPlSeg       ;
                xchg    dx,es:[bx]       ;Mark old place of context as free
                mov     DiTmp,di         ;
                mov     SiTmp,si         ;
                mov     CxTmp,cx         ;
                mov     al,Char          ;
                mov     es,DictSeg       ;
                mov     bx,ds            ;
                mov     ds,DictSeg       ;
                rep     movsb            ;move context to the new place
                stosb                    ;write at the end Char
                mov     cx,cs:CxTmp      ;
                mov     di,cs:DiTmp      ;
                mov     si,cs:SiTmp      ;
                add     di,8000h         ;
                add     si,8000h         ;
                rep     movsb            ;Move frequencies
                mov .b  es:[di],01       ;Initial frequency is equal 1
                mov     cx,cs:CxTmp      ;
                mov     si,cs:SiTmp      ;
                mov     di,cs:DiTmp      ;
                add     si,si            ;
                add     di,di            ;
                mov     ax,cx            ;
                mov     ds,bx            ;Reset ds
                mov     es,LinksSeg      ;
                mov     ds,LinksSeg      ;
                rep     movsw            ;Move context Links
                mov .w  es:[di],0ffffh   ;New character has no links!
                mov     ds,bx            ;Reset ds
                mov     si,SiTmp         ;Get old beginning of context
                add     si,si            ;Save content of FrPl[OldSize*2]
                mov     es:[si],dx       ; in Links
                ret                      ;
SiTmp           dw      ?
DiTmp           dw      ?
CxTmp           dw      ?
CInfoOffs       dw      ?
AddToCntx       endp

;Parse the command line for parameters
CmdLParse       proc   near
                mov     si,80h
                mov     cl,.b [si]       ;
                mov     di,.o FNameW     ;
                cmp     cl,01            ;Any parameters?
                ja      @@RCmdl          ;If yes, parse
                Quit    CopyRight        ; else, display Copyright and exit
@@RCmdl:        inc     si
                call    SkipBlanks       ;
                cmp     al,CR            ;Is it a carriage return ?
                jz      @@CprtMsg        ; If yes, display Copyright message
                and     al,0dfh          ;  else, capitalize letter
                cmp     al,'A'           ;If a letter is 'A', pack file
                jnz     @@IsDec          ; else check al for 'E'
                mov     Encode,01        ;
                jmp .s  @@2              ;
@@IsDec:        cmp     al,'E'           ;If the letter is 'E', unpack file
                jnz     @@CprtMsg        ; Else, display Copyright message
                mov     Encode,00        ;
@@2:            call    SkipBlanks
                cmp     al,CR            ;Is it a carriage return ?
                jz      @@CprtMsg        ; If yes, display Copyright message
                mov     di,.o FNamew     ;DI points to Archive filename
                stosb                    ;Put first letter of filename
@@NxtR:         lodsb                    ;Get next letter
                cmp     al,CR            ;Is it a carriage return ?
                jz      @@WhatMode       ; If yes, check archiver mode
                cmp     al,20h           ;It is an end of filename?
                jz      @@RdSecName      ; If yes, read second file name
                stosb                    ;Put next letter of filename
                jmp .s  @@NxtR           ; Get next letter
                jmp     short @@RdSecName ; Read second file name
@@WhatMode:     cmp     Encode,00        ;
                jnz     @@CprtMsg        ;
                jmp .s  @@Exit           ;
@@RdSecName:    mov     al,00
                stosb                    ;Zero marks the end of filename
                call    SkipBlanks       ;
                cmp     al,CR            ;
                jnz     @@GetName        ;
                cmp     Encode,00
                jnz     @@CprtMsg        ;
                jmp .s  @@Exit           ;

@@GetName:      mov     di,.o FNameR     ;DI points to second filename
                stosb                    ;Put first letter of filename
@@NxtB:         lodsb                    ;Get next letter
                cmp     al,CR            ;See if current letter is CR
                jz      @@EndOfNm        ; or
                cmp     al,20h           ;  blank
                jz      @@EndOfNm        ; If so, end of filename occured
                stosb                    ;Put next letter of filename
                jmp .s  @@NxtB           ;
@@EndOfNm:      mov     al,00            ;
                stosb                    ;Mark the end of filename with zero
@@Exit:         ret
@@CprtMsg:      Quit    Copyright        ;Display Copyright message and
CmdLParse       endp                     ; exit to DOS



SkipBlanks      proc   near
@@NxtBl:        lodsb
                cmp    al,20h
                jz     @@NxtBl            ;
                ret
SkipBlanks      endp

;Convert Double Word dx:ax to ASCII string
;(Randall Hyde's UCR Standard Library)
DwToAscii       proc    near
		call	Div10
		cmp	ax, dx		;See if dx:ax=0
                jnz     @@NotDone       ;
                or      ax, ax          ;
                jz      @@Done          ;
@@NotDone:      push    bx              ;
                call    DwToAscii       ;
                pop     bx              ;
@@Done:         mov     al, bl          ;
                or      al, '0'         ;
                mov     ds:[di], al     ;
		inc	di
		ret
DwToAscii       endp

; Div10- Divides DX:AX by 10 leaving the remainder in BL and the quotient
;        in DX:AX. (Randall Hyde's UCR Standard Library)
Div10		proc	near
                mov     cx, 10d
		mov	bx, ax
		xchg	ax, dx
		xor	dx, dx
		div	cx
		xchg	bx, ax
		div	cx
		xchg	dx, bx
		ret
Div10		endp


GetName         proc    near
                push    ds
                pop     es
                mov     di,.o PName
@@NxtB:         lodsb
                or      al,al
                jz      @@AllDown
                stosb
                jmp .s  @@NxtB
@@AllDown:      mov     al,20h
                mov     cx,04
                rep     stosb
                mov .b  [di],'$'
                ret
GetName         endp

GetNOfBl        proc     near
                Open     FNameR
                mov      RHandle,ax
                mov      bx,ax               ;
                                             ;Go to the end of file
                FSeek    02,<xor cx,cx>,<xor dx,dx>
                mov      cx,InpBSize         ;cx=size of input buffer
                div      cx
                mov      NofBl,ax            ;Save number of blocks and
                mov      Remndr,dx           ; remainder
                mov      bx,RHandle
                                             ;Return to the file beginning
                Fseek    00,<xor cx,cx>,<xor dx,dx>
                call     AddHap              ;Add .hap exstension
                Create    FNameW,00          ;Create file for packed data

                mov      WHandle,ax          ;Save handle
                mov      bx,ax
                Write    ,16d,FstHdrRow      ;Write first line of header
                Write    ,16d,SecHdrRow      ;Write second line
                mov      ah,2fh              ;
                int      21h                 ;Get Disk Transfer Area (DTA)address
                mov      DTASeg,es           ;Store DTA address High part
                mov      ah,4eh
                mov      cx,0ffh
                mov      dx,.o FNameR        ;
                int      21h                 ;Find first
                push     ds
                mov      ds,DTASeg
                mov      dx,80h
                mov      di,dx
                mov .b   [di+43d],16h
                add      dx,15h
                mov      cx,23d
                mov      bx,cs:WHandle
                call     FWrite
                pop      ds
                ret
GetNofBl        endp


;add .HAP exstension
AddHap          proc     near
                mov      si,.o FNameW
@@NxtB:         lodsb
                cmp      al,'.'
                jz       @@AddHap
                cmp      al,00
                jz       @@AddHap
                cmp      al,' '
                jz       @@AddHap
                jmp .s   @@NxtB
@@AddHap:       mov .b   [si-1],'.'
                mov .b   [si],  'h'
                mov .b   [si+1],'a'
                mov .b   [si+2],'p'
                mov .b   [si+03],00
                ret
AddHap          endp

;Write the size of packed data
WrPckSize       proc     near
                mov      bx,WHandle
                FSeek    02,<xor cx,cx>,<xor dx,dx>
                                              ;dx:ax is equal to file length
                sub      ax,55d
                sbb      dx,00                ;Substract header length
                mov      LPSize,ax
                mov      HPSize,dx
                FSeek    00,<xor cx,cx>,<mov dx,19d>
                Write     ,04,LPSize          ;Write the size of packed data
                ret
WrPckSize       endp

;Display a string terminated with a $ and check for Ctrl-Break
LDisp           proc near
                push ds
                push cs
                pop  ds
                mov  ah,09
                int  21h
                pop  ds
                ret
LDisp           endp

;Set file date,time and attribute
SetDate         proc     near
                mov      bx,RHandle
                mov      ax,5701h
                mov      cx,Time
                mov      dx,Date
                int      21h                  ;Set file's date and time
                Close    RHandle
                mov      ax,4301h
                mov      dx,.o FNameR
                sub      cx,cx
                mov      cl,Attrib
                int      21h                  ;Set file attribute
                ret
SetDate         endp

FOpen           proc  near
                mov      ax,3d00h
                int      21h                    ;Open file for reading
                jnc      @@Exit                 ; If no error, exit
                message  OpenErr                ;Otherwise print a message
                mov      si,.o FNameW
                cmp      Encode,00
                jz       @@PrepName             ;
                mov      si,.o FNameR
@@PrepName:     call     GetName
                Message  PName                  ;
                call     DosExit                ;Exit to DOS
@@Exit:         ret
FOpen           endp

FCreate         proc     near
                push     dx
                call     CbdBufCl
                mov      ax,3d00h
                int      21h                 ;Try to open file
                jc       @@Create            ; File does not exist,create it
                mov      bx,ax
                call     FClose
                message  Warning
                mov      si,.o FNamer
                cmp      Encode,00
                jz       @@GetName           ;
                mov      si,.o FNamew
@@GetName:      call     GetName
                Message  PName
                Message  AlrExst
@@Wait:         mov      ah,01h
                int      16h                 ;Is there a keystroke available?
                jz       @@Wait              ;
                xor      ah,ah               ;
                int      16h                 ;
                cmp      ah,31h              ;'N'
                jz       @@Quit              ;
                cmp      ah,15h              ;'Y'
                jnz      @@Wait              ;
                message  CRLF
@@Create:       pop      dx
                mov      ah,3ch              ;Create file
                int      21h
@@Exit:         ret
@@Quit:         pop      dx
                Quit     NothToDo             ;'Nothing to do!'
FCreate         endp


LSeek           proc     near
                mov      ah,42h
                int      21h
                ret
LSeek           endp

FRead           proc     near
                mov      ah,3fh
                int      21h
                ret
FRead           endp

FWrite          proc     near
                mov      ah,40h
                int      21h
                cmp      ax,cx
                jz       @@Exit
                Message  WrErr
                Close    WHandle
                Close    RHandle
                mov      dx,.o FNameW
                cmp      Encode,01
                jz       @@FDel
                mov      dx,.o FNameR
@@FDel:         call     FDel
                call     DosExit
@@Exit:         ret
FWrite          endp

FClose          proc     near
                mov      ah,3eh
                int      21h
                ret
FClose          endp

FDel            proc     near
                mov      ah,41h
                int      21h
                ret
FDel            endp


;Erase characters from buffer
CbdBufCl        proc near
                mov     ax,40h               ;Point to the ROM BIOS data area
                mov     es,ax
                push    WORD PTR es:[1ah]    ;If Head equals
                pop     WORD PTR es:[1ch]    ; Tail, then buffer is empty
                ret
CbdBufCl        endp

;Set Ctrl-Break handler
SetCtrlBR       proc     near
                push     es
                mov      ax,3523h
                int      21h                  ;Get Ctrl-BREAK handler
                mov      CtrlBrOffs,bx        ; and immediately
                mov      CtrlBrSeg,es         ; save it
                mov      DX,.o CtrlBrTerm     ;Set Ctrl-Break exit
                mov      AX,2523h             ; to terminate
                Int      21h                  ; that way
                pop      es
                ret
SetCtrlBr       endp

;Ctrl-BREAK terminate - delete destination file and exit
CtrlBrTerm:     push     cs
                pop      ds
                Close    WHandle
                Close    RHandle
                mov      dx,.o FNameW
                cmp      Encode,01
                jz       @@Rghtname              ;
                mov      dx,.o FNameR
@@RghtName:     call     Fdel
                Quit     Break

;  DOS
DosExit         proc    near
                mov     ax,2523h
                lds     dx,.d cs:CtrlBrOffs     ;Restore Ctrl-Break
                int     21h                     ; Handler
                mov     ah,4ch
                int     21h                     ;Exit to DOS
DosExit         endp

FNameW       db      13d dup (?)
WHandle      dw      ?
AttRib       db      ?
Time         dw      ?
Date         dw      ?
OutFSzL      dw      ?
OutFSzH      dw      ?
FNameR       db      13d dup (?)
RHandle      dw      ?
DTASeg       dw      ?
LPSize       dw      ?
HPSize       dw      ?
FstHdrRow    db      '3HF',11d dup(00),8eh
SecHdrRow    db      'hJW',13d dup(00)

Copyright    db      'T[iny]Hap 1.02c, Copyright (C) 1995 Alexander Krupnik ',CR,LF
             db      'This file-compression utility is a reconstructed HAP&PAH v.3.0 ',CR,LF
             db      'Copyright (C) 1992  Harald Feldmann',CR,LF,CR,LF

             db      'Usage:  THap  a|e  ArchiveName  [FileName]',CR,LF,'$'
OpenErr      db      'Can''t find    $'
WrErr        db      CR,LF,'Can''t write file. Disk full?  $'
NofBl        dw      ?
Remndr       dw      ?
PFlag        db      ?
InCntL       dw      ?
InCntH       dw      ?
OutCntL      dw      ?
OutCntH      dw      ?
Warning      db      'Warning!  $'
NoMem        db      'Out of memory',CR,LF,'$'
Break        db      'Break signaled! $'
IsNHap       db      'is not a HAP 3.0 archive',CR,LF,'$'
AlrExst      db      'already exist. Overwrite(y/n)? $'
NothToDo     db      CR,LF,'Nothing to do!',CR,LF,'$'
CRLF         db      CR,LF,'$'
CtrlBrOffs   dw      ?
CtrlBrSeg    dw      ?
Packing      db      'Packing:  ','$'
UnPacking    db      'Unpacking:  ','$'
Digit        db      20d dup (?)
Arrow        db      '=> ','$'
Digit1       db      20d dup (?)
Ok           db      CR,LF,'Ok',CR,LF,'$'
CntxSzOffs   dw      ?
CntxSzSeg    dw      ?
CntxIniOffs  dw      ?
CntxIniSeg   dw      ?
DictOffs     dw      ?
DictSeg      dw      ?
FreqOffs     dw      ?
FreqSeg      dw      ?
LinksOffs    dw      ?
LinksSeg     dw      ?
FrPlOffs     dw      ?
FrPlSeg      dw      ?
ElimOffs     dw      ?
ElimSeg      dw      ?
Low          dw      ?
High         dw      ?
UFlBits      dw      ?
PackOffs     dw      ?
BToSave      db      ?
BitCnt       db      ?
Char         db      ?
CntxIniPnt   dw      ?
CntxNmb      dw      ?
ElimPnt      dw      ?
LCnt         dw      ?
HCnt         dw      ?
Scale        dw      ?
PName        db      17d dup (?)
OutBCnt      dw      ?
Value        dw      ?
CntxIni      dw      NofCntx dup (?)
CntxSize     dw      NofCntx dup (?)
DecBCnt      dw      ?
ByteRdd      db      ?
ChNbr1       dw      ?
Encode       dw      ?
CntxInd      dw      NofCntx dup (?)
PrevCntxInd  dw      NofCntx dup (?)
ChNbr        dw      NofCntx dup (?)
PrevChNbr    dw      NofCntx dup (?)
FrAddr       dw      NofCntx dup (?)
CntxStat     dw      NofCntx dup (?)
ReadBuff     db      InpBSize  dup (?)
PackBuff     db      PackBSize dup (?)

             cseg    ends
             end     Main
